﻿import { Action } from './Action.js';
import { toBool } from '../lib/utils.js';

/**
 * @class OpenMarkerWindow
 * @extends Action
 * @classdesc Действие Открыть всплывающее окно маркера
 * */
export class OpenMarkerWindow extends Action {
    execute(context) {
        /*if ($pm.hasPermissions) {
            const targetContext = context.target || context.currentTarget;
            $pm.resolveOpenWindow(targetContext, this.WindowId, this.ObjectId, this.continueExecution.bind(this, context));
        } else {*/
        this.continueExecution(context);
        //}
    }

    continueExecution(context) {
        let options = {
            width: this._width,
            height: this._height,
            canclose: this._canClose,
            sizetocontent: this._sizeToContent,
            closeonnewwindow: this._closeOnNewWindow,
            closeonlostfocus: this._closeOnLostFocus,
            windowid: this.WindowId,
        };

        //add objectid, task id and outerpath
        let id = context.detail.id;
        const targetContext = context.target || context.currentTarget;
        targetContext.openMarkerWindow(id, options)
    }


    get CanClose() {
        return this._canClose;
    }
    set CanClose(v) {
        this._canClose = v;

    }

    get Width() {
        return this._width;
    }
    set Width(v) {
        this._width = v;

    }

    get Height() {
        return this._height;
    }
    set Height(v) {
        this._height = v;

    }

    get SizeToContent() {
        return this._sizeToContent;
    }
    set SizeToContent(v) {
        this._sizeToContent = v;
    }

    get objectId() {
        return this._ObjectId;
    }
    set objectId(v) {
        this._ObjectId = Number(v);
    }



    get CloseOnNewWindow() {
        return this._closeOnNewWindow;
    }
    set CloseOnNewWindow(v) {
        this._closeOnNewWindow = toBool(v);
    }

    get CloseOnLostFocus() {
        return this._closeOnLostFocus;
    }

    set CloseOnLostFocus(v) {
        this._closeOnLostFocus = toBool(v);
    }

    destroy() {

    }
}
