﻿import { Action } from './Action.js';
/**
 * @class OpenWindow
 * @extends Action
 * @classdesc Действие Открыть окно
 * */
export class OpenWindow extends Action {
    execute(context) {
        if ($pm.hasPermissions) {
            const targetContext = context.target || context.currentTarget;
            $pm.resolveOpenWindow(targetContext, this.WindowId, this.ObjectId, this.continueExecution.bind(this, this.context));
        } else {
            this.continueExecution();
        }
    }
    continueExecution() {

        if (this.OpenNew == true) {
            window.open(`?${this.WindowId}`, '_blank');
        } else {
            let frame;
            if (this.FrameId)
                frame = document.getElementById(this.FrameId);
            else
                frame = document.querySelector("ms-frame");

            let windDef = $WinDefs.winDef[this.WindowId];

            const { objectid, taskid, outerpath } = windDef.objectid === '0' ?
                $sw.ItemSubscription.GetInstanceFields(this) : windDef;
            let windModel = {
                ...windDef,
                ...(objectid ? { objectid } : {}),
                ...(taskid ? { taskid } : {}),
                ...(outerpath ? { outerpath } : {}),
            }
            const win = frame.openWindow(windModel);
            if (this.parameters) {
                for (const key in this.parameters) {
                    win.SetParameter(key.toLowerCase(), this.parameters[key]);
                }
            }
        }
    }
}