﻿// <copyright file="ParameterRoles.js" company="ИнСАТ">
// ИнСАТ, 2014
// </copyright>
// 

define([], function () {

    //Constants for predefined parameter roles

    var ParameterRoles = {
        ID: 'Id',
        ROLE: 'RoleAttribute',
        NAME: 'Name',
        X: 'X',
        Y: 'Y',
        Z: 'Z',
        WIDTH: 'Width',
        HEIGHT: 'Height',
        ANGLE: 'Angle',
        SCALE_X: 'ScaleX',
        SCALE_Y: 'ScaleY',
        SCREW_X: 'ScrewX',
        SCREW_Y: 'ScrewY',
        ANCHOR: 'Anchor',

        X_UNITS: 'XType',
        Y_UNITS: 'YType',
        WIDTH_UNITS: 'WidthType',
        HEIGHT_UNITS: 'HeightType',

        START_SCREEN: 'StartScreen',
        PROPORTION_TYPE: 'ProportionType',
        DISABLE_SCALE: 'DisableScale',

        DOCK_STYLE: 'DockStyle',

        INTERVALS_NUMBER: 'IntervalsNumber',
        UNIT: 'Unit',
        INTERVAL_TICKS_NUMBER: 'IntervalTicksNumber',
        SCALE_COLOR: 'ScaleColor',
        SHOW_VALUE: 'ShowValue',
        PRECISION: 'Precision',
        ARROW_COLOR: 'ArrowColor',

        SLIDER_SIZE: 'SliderSize',
        FORE_COLOR: 'ForeColor',
        FILL_COLOR: 'FillColor',
        FORE_BORDER_RADIUS: 'ForeBorderRadius',
        FORE_BORDER_WIDTH: 'ForeBorderWidth',
        FORE_BORDER_COLOR: 'ForeBorderFill',
        IS_OVERFLOW: 'IsOverflow',
        OVERFLOW_SIZE: 'OverflowSize',

        COLOR: 'Color',
        TEXT_COLOR: 'TextColor',
        TEXT_SHADOW_COLOR: 'TextShadowColor',
        TEXT_SHADOW_SIZE: 'TextShadowSize',
        COLOR_SELECT: 'ColorSelect',
        PEN_COLOR: 'PenColor',
        BACKGROUND_COLOR: 'BackgroundColor',
        BORDER_THIKNESS: 'BorderThickness',
        BORDER_COLOR: 'BorderColor',
        BORDER_STYLE: 'BorderStyle',
        CORNER_RADIUS: 'CornerRadius',
        OPACITY: 'Opacity',
        SHADOW_SIZE: 'ShadowSize',
        SHADOW_COLOR: 'ShadowColor',
        BORDER_GEOMETRY: 'BorderGeometry',
        BORDER_CLIP_GEOMETRY: 'BorderClipGeometry',
        THEME: 'Theme',
        BACKGROUND_TILE: 'BackgroundTile',
        LAYOUT: 'Layout',

        CUT_COLOR: 'CutColor',
        CUT_THICKNESS: 'CutThickness',

        CONE_RATIO: 'ConeRatio',
        RADIUS: 'Radius',
        TUBE_DIAMETER: 'TubeDiameter',
        INITIAL_ANGLE: 'InitialAngle',
        FINAL_ANGLE: 'FinalAngle',

        HORIZONTAL_ALIGN: 'HorizontalElementsAlign',
        VERTICAL_ALIGN: 'VerticalElementsAlign',
        ORIENTATION: 'Orientation',

        COL: 'Col',
        ROW: 'Row',
        COLSPAN: 'Colspan',
        ROWSPAN: 'Rowspan',
        COLUMN_DEFINITION: 'ColumnDefinition',
        ROW_DEFINITION: 'RowDefinition',

        IS_VISIBLE: 'IsVisible',
        IS_ENABLED: 'IsEnabled',
        IS_READONLY: 'IsReadonly',
        IS_CHECKED: 'IsChecked',
        IS_PRESSED: 'IsPressed',
        IS_FIXED: 'IsFixed',

        CLASSID: 'ClassId',
        CODEBASE: 'Codebase',
        PARAMETERS: 'Parameters',
        CAB: 'Cab',

        TOOL_TIP: 'ToolTip',
        TAB_INDEX: 'TabIndex',
        SCALE_CONTENT: 'ScaleContent',
        FLASH: 'Flash',
        RESOURCE: 'Resource',
        SKIN: 'SkinResource',
        FONT_NAME: 'FontName',
        FONT_SIZE: 'FontSize',

        FONT_MULTILINE: 'FontMultiline',
        FONT_ITALIC: 'FontItalic',
        FONT_BOLD: 'FontBold',
        FONT_UNDERLINED: 'FontUnderlined',

        TEXT: 'Text',
        TEXT_VERTICAL_ALIGN: 'TextVerticalAlign',
        TEXT_HORIZONTAL_ALIGN: 'TextHorizontalAlign',

        KEYBOARD_VISIBILITY: 'KeyboardVisibility',
        KEYBOARD_TYPE: 'KeyboardType',

        VALUE: 'Value',
        VALUE_FORMAT: 'ValueFormat',
        MASK: 'Mask',
        MAX_LENGTH: 'MaxLength',
        MIN_VALUE: 'MinValue',
        MAX_VALUE: 'MaxValue',
        INCREMENT_STEP: 'IncrementStep',
        DISPLAY_NAME: 'DisplayName',

        MARKS: 'Marks',

        TIME: 'Time',
        DATE_TIME: 'DateTime',
        DATE_TIME_TYPE: 'DateTimeType',
        TIME_FORMAT: 'TimeFormat',
        DATE_FORMAT: 'DateFormat',

        ITEM_SOURCE: 'ItemsSource',
        SELECTED_ITEM: 'SelectedItem',

        FREEZE_CURSOR: 'FreezeCursor',
        INTERVAL: 'Interval',
        TITLE: 'Title',
        MIN_X: 'MinX',
        MIN_Y: 'MinY',
        MAX_X: 'MaxX',
        MAX_Y: 'MaxY',

        X_AXIS_STROKE_COLOR: 'AxisColorX',
        X_AXIS_FILL_COLOR: 'AxisFillX',
        X_AXIS_THICKNESS: 'AxisThicknessX',

        X_MAJOR_TICK_COUNT: 'TickCountX',
        X_MAJOR_TICK_WIDTH: 'TickWidthX',
        X_MAJOR_TICK_HEIGHT: 'TickHeightX',
        X_MAJOR_TICK_COLOR: 'TickColorX',

        X_MAJOR_TICK_PADDING_LEFT: 'TickMarginLeftX',
        X_MAJOR_TICK_PADDING_RIGHT: 'TickMarginRightX',
        X_MAJOR_TICK_PADDING_BOTTOM: 'TickMarginBottomX',
        X_MAJOR_TICK_PADDING_TOP: 'TickMarginTopX',

        X_AXIS_FORMAT: 'XFormat',

        X_AXIS_LABEL: 'XAxisLabel',
        Y_AXIS_LABEL: 'YAxisLabel',
        /*X_FORMAT: 'XFormat',*/

        Y_AXIS_STROKE_COLOR: 'AxisColorY',
        Y_AXIS_FILL_COLOR: 'AxisFillY',
        Y_AXIS_THICKNESS: 'AxisThicknessY',

        Y_MAJOR_TICK_COUNT: 'TickCountY',
        Y_MAJOR_TICK_WIDTH: 'TickWidthY',
        Y_MAJOR_TICK_HEIGHT: 'TickHeightY',
        Y_MAJOR_TICK_COLOR: 'TickColorY',

        Y_MAJOR_TICK_PADDING_LEFT: 'TickMarginLeftY',
        Y_MAJOR_TICK_PADDING_RIGHT: 'TickMarginRightY',

        GRID_LINE_THICKNESS: 'GridThickness',
        GRID_LINE_STROKE_COLOR: 'GridColor',
        GRID_LINE_FILL_COLOR: 'GridFill',

        HI_AVARY: 'HiAvary',
        HI_WARNING: 'HiWarning',
        LOW_AVARY: 'LowAvary',
        LOW_WARNING: 'LowWarning',

        CURSOR_COLOR: 'CursorColor',
        CURSOR_THICKNESS: 'CursorThickness',
        CURSOR_MAXCOUNT: 'CursorMaxCount',
        CURSOR_CUT_COLOR: 'CursorCutColor',
        SHOW_CURSOR: 'ShowCursor',
        SHOW_SERVER_CURSOR: 'ShowServerCursor',

        SHIFT: 'Shift',
        TILL: 'Till',
        Y_FORMAT: 'YFormat',
        AUTOSCALE: 'Autoscale',
        AUTOSCROLL: 'Autoscroll',
        DATA_SOURCE: 'DataSource',
        LOW_RESOLUTION_MODE: 'LowResolutionMode',
        CHART_BACKGROUND: 'ChartBackground',
        TICK_COUNT_Y: 'TickCountY',
        TICK_COUNT_X: 'TickCountX',
        INTERVAL_PAGES_TURN: 'IntervalPageTurn',
        RESAMPLE_INTERVAL: 'ResampleInterval',
        TREND_LINES: 'Pens',
        TREND_LIMITS: 'PenLimits',
        UPDATE_TIME: 'UpdateTime',
        LINE_WIDTH: 'Thickness',
        LINE_JOIN: 'LineJoin',
        LINE_STYLE: 'LineStyle',
        FALSEY_VALUES_LINESTYLE: 'FalseValuesLineStyle',
        DRAW_CONSTANT: 'DrawConstant',
        FILL_DIRECTION : 'FillDirection',

        LOAD_INVISIBLE_CONTENT: 'LoadInvisibleContent',
        ATTACH: 'Attach',

        HORIZONTAL_ELEMENTS_ALIGN: 'HorizontalElementsAlign',
        VERTICAL_ELEMENTS_ALIGN: 'VerticalElementsAlign',
        LAST_CHILD_FILL: 'LastChildFill',
        SIZE_TO_CONTENT: 'SizeToContent',

        SOURCE: 'Source',
        TARGET: 'Target',
        OPERATION: 'Operation',

        IS_GLOBAL: 'IsGlobal',
        OBJECT_UID: 'ObjectUID',

        LIMIT: 'Limit',
        SHOW_LEGEND: 'ShowLegend',
        SHOW_GRID: 'ShowGrid',
        SHOW_FILTER: 'ShowFilter',
        SHOW_TOOLBAR: 'ShowToolbar',
        FULL_SCREEN: 'FullScreen',
        LEGEND_BACKGROUND_COLOR: 'LegendBackgroundColor',
        TOOLBAR_BACKGROUND_COLOR: 'ToolbarBackgroundColor',
        FILTERS_BACKGROUND_COLOR: 'FiltersBackgroundColor',
        PAGE_INTERVAL: 'PageInterval',
        RIGHT_BORDER: 'RightBorder',
        LEFT_BORDER: 'LeftBorder',
        PAGE_MESSAGE_COUNT: 'PageMessageCount',
        PAGE_RIGHT_BORDER: 'PageRightBorder',
        AUTOSCROLL_STOP_REASON: 'AutoscrollStopReason',
        USE_ARCHIVE: 'UseArchive',
        HAS_MESSAGES: 'HasMessages',

        UPDATE_PERIOD: 'UpdatePeriod',
        FILTERS: 'Filters',
        ENABLED: 'Enabled',
        CAN_DISABLE: 'CanDisable',
        CONDITION: 'Condition',
        TABLE_COLUMNS: 'TableColumns',
        IS_PAGED: 'IsPaged',
        VISIBILITY: 'Visibility',
        ROW_HEIGHT:'RowHeight',
        FIELD: 'Field',
        FIELD_TYPE: 'FieldType',
        FIELD_TYPE_HASH: 'FieldTypeHash',
        SORT: 'Sort',
        SORT_POSITION: 'SortPosition',
        COLUMN_WIDTH: 'ColumnWidth',

        ITEM_ID: 'ItemID',
        TASK_ID: 'TaskID',

        LEGEND_COLUMNS: 'LegendColumns',
        ROW_STYLE: 'RowStyle',
        SELECTED_ROW_STYLE: 'SelectedRowStyle',
        HEADER_ROW_STYLE: 'HeaderRowStyle',


        REQUEST_SERVER_PREFIX: 'RequestServerPrefix',
        BROWSER_LOG: 'BrowserLog',
        UPDATE_INTERVAL: 'UpdateInterval',
        FLASH_INTERVAL: 'FlashInterval',
        TYPES_COUNT: 'TypesCount',
        UNIQUE_TYPES_COUNT: 'UniqueTypesCount',

        SHOW_CONNECTION_ICONS: 'ShowConnectionIcons',
        SHOW_NOT_ACKED_MESSAGES_ICON: 'ShowNotAckedMessagesIcon',
        SHOW_ACK_BUTTON: 'ShowAckButton',

        PANEL_DATA_SOURCE: 'PanelDataSource',

        LANGUAGE: 'Language',
        HAS_FB_CONNECTIONS: 'hasFBConnections',
        AUTO_POPUP: 'AutoPopup',

        URL: 'Url',
        FILTER: 'Filter',

        DIALOG_HEADER_TEXT_COLOR: 'HeaderFontColor',
        DIALOG_HEADER_HEIGHT: 'DialogHeaderSize',
        DIALOG_HEADER_FONT_SIZE: 'DialogFontSize',
        DIALOG_HEADER_FONT_NAME: 'DialogFontName',
        HEADER_BACKGROUND_COLOR: 'HeaderBackgroundColor',

        ARCHIVE_END: 'ArchiveEnd',
        ARCHIVE_START: 'ArchiveStart',

        ADDRESS: 'Address',
        CAN_MINIMIZE: 'CanMinimize',
        CAN_CLOSE: 'CanClose',
        CAN_RESIZE: 'CanResize',
        OPEN_DIALOG_POINT: 'OpenDialogPoint'
    };

    return ParameterRoles;
});
